//CxTranslator.cpp
//Copyright  2001-2005 Easy Math Solution. All Rights Reserved
//http://www.e-MathSolution.com
//For details contact us: info@e-MathSolution.com

#include "CxTranslatorEx.h"


//Define functions name
TEvaluateEqu            EvaluateEqu;
TEvaluate               Evaluate;
TBuildEqu       	BuildEqu;
TBuild                  Build;
TCalcFor                CalcFor;
TAddFunction            AddFunction;
TRemoveFunction         RemoveFunction;
TAddConst               AddConst;
TRemoveConst            RemoveConst;
TSetErrorHandle         SetErrorHandle;
HINSTANCE hDLL;



//////////////////////////////////////////////////////////////////
//Set error handle
#if defined(__BORLANDC__)
void __stdcall RiaseException(const TCHAR*err) throw( CxException)
{
        throw CxException(err);
}
#endif


////////////////////////////////////////////////////////////////////
//Load CxTranslator(W).dll and init interface
bool LoadCxTranslator(void)
{
    bool result=true;
	
#if defined(_UNICODE)
	if((hDLL = LoadLibrary(_T("CxTranslatorW.dll")))==NULL)
#else
	if((hDLL = LoadLibrary(_T("CxTranslator.dll")))==NULL)
#endif
           return false;

        EvaluateEqu=(TEvaluateEqu)GetProcAddress(hDLL,_T("EvaluateEqu"));
        Evaluate=(TEvaluate)GetProcAddress(hDLL,_T("Evaluate"));
        BuildEqu=(TBuildEqu)GetProcAddress(hDLL,_T("BuildEqu"));
        Build=(TBuild)GetProcAddress(hDLL,_T("Build"));
        CalcFor=(TCalcFor)GetProcAddress(hDLL,_T("CalcFor"));
        AddFunction=(TAddFunction)GetProcAddress(hDLL,_T("AddFunction"));
        RemoveFunction=(TRemoveFunction)GetProcAddress(hDLL,_T("RemoveFunction"));
        AddConst=(TAddConst)GetProcAddress(hDLL,_T("AddConst"));
        RemoveConst=(TRemoveConst)GetProcAddress(hDLL,_T("RemoveConst"));
        SetErrorHandle=(TSetErrorHandle)GetProcAddress(hDLL,_T("SetErrorHandle"));


	//Check if success 
    if( !EvaluateEqu ||  !Evaluate ||   !BuildEqu ||   !Build ||
        !CalcFor || !AddFunction || !RemoveFunction || !AddConst ||
        !RemoveConst || !SetErrorHandle)
           return false;

	//Send CALLBACK function to CxTranslator
#if defined(__BORLANDC__)
     SetErrorHandle(RiaseException );
#endif

     return result;
}


//////////////////////////////////////////////////////////////////
//UnLoad CxTranslator(W).dll
void UnLoadCxTranslator(void)
{
        SetErrorHandle(NULL);
        if(hDLL)
                FreeLibrary(hDLL);
}



