// Demo.cpp : 
//CxTranslator algorithm version 1.1
//Copyright  2001-2005 Easy Math Solution. All Rights Reserved
//http://www.e-MathSolution.com
//For details contact us: info@e-MathSolution.com

using System;

namespace CSharpTest
{
	
	class Class1
	{
		
//User defined function
		static EMS.Complex qub(ref EMS.Complex x)
		{
			EMS.Complex res;
			res.re=x.re*x.re*x.re;
			res.im=x.im*x.im*x.im;
			return res;
		}

		
		
		[STAThread]
		static void Main(string[] args)
		{
			EMS.Complex [] arg= new EMS.Complex[2];
			EMS.Complex res=new EMS.Complex();
			EMS.Complex myConst= new EMS.Complex();

			string mExp="f(x,y)=x+(5i+y)^2-exp(x)/qub(x/y)+myConst";
			arg[0]=new EMS.Complex();
			arg[1]=new EMS.Complex();

			arg[0].re=5; arg[0].im=2; 
			arg[1].re=2; arg[1].im=1; 
			
			myConst.re=5.7;  myConst.im=2.4;

			//Delegate for the user defined function
			EMS.CxTranslator.CallBackUserFunction qubDelegate=
				new EMS.CxTranslator.CallBackUserFunction(qub);

			try
			{
				EMS.CxTranslator.SetEquTranslatorException();//Set error handle
				EMS.CxTranslator.AddConst("myConst", myConst);
				EMS.CxTranslator.AddFunction("qub",qubDelegate);

				EMS.CxTranslator.BuildEqu("f(x,y)=exp(x)^2+x/y+6i+qub(myConst)");
				res=EMS.CxTranslator.CalcFor(arg);
				Console.WriteLine("res.re={0}   res.im={1}",res.re, res.im);

				res=EMS.CxTranslator.EvaluateEqu(mExp, arg);
				Console.WriteLine("res.re={0}   res.im={1}",res.re, res.im);
				
				EMS.CxTranslator.RemoveConst("myConst");
				res=EMS.CxTranslator.Evaluate("x,y", "(x+sqrt(y))-myConst", arg);
				Console.WriteLine("res.re={0}   res.im={1}",res.re, res.im);

			} 
			catch(Exception e)
			{
				Console.WriteLine(e.Message);
			}

			Console.ReadLine();
		}
	}
}
